Attribute VB_Name = "Registry"
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Use ONLY THESE Functions/Subs:                                                                     '
' Value = RegGetValue(HKEY-WhichOne, KeyName, ValueName) - Gets A Registry Value                    '
' RegMakeKey(HKEY-WhichOne, KeyName) - Makes A Registry Key                                         '
' RegSetValue(HKEY-WhichOne, KeyName, ValueName, Value) - Sets A Registry Value                     '
' RegShootTheDamnKey(HKEY-WhichOne, KeyName) - Deletes A Registry Key                               '
' RegShootTheDamnValue(HKEY-WhichOne, KeyName, ValueName) - Deletes A Registry Value                '
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Note: HKEY-WhichOne may be vbClassesRoot, vbCurrentUser, vbLocalMachine, vbUsers or vbCurrentConfig'
'Note: KeyName may be vbDefault for the (Default) tag                                               '
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Declare Function RegCreateKeyEx& Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult As Long, lpdwDisposition As Long)
Declare Function RegSetValueEx& Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpszValueName As String, ByVal dwRes As Long, ByVal dwType As Long, ByVal lpDataBuff As String, ByVal nSize As Long)
Declare Function RegCloseKey& Lib "advapi32.dll" (ByVal hKey As Long)
Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, ByRef phkResult As Long) As Long
Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

Type SECURITY_ATTRIBUTES
   nLength As Long
   lpSecurityDescriptor As Long
   bInheritHandle As Long
End Type

' vbClassesRoot = &H80000000
' vbCurrentUser = &H80000001
' vbLocalMachine = &H80000002
' vbUsers = &H80000003
' vbCurrentConfig = &H80000005
' vbDefault = ""

Const KEY_ALL_ACCESS = &H3F
Const KEY_CREATE_SUB_KEY = &H4&
Const KEY_SET_VALUE = &H2&
Const READ_CONTROL = &H20000
Const STANDARD_RIGHTS_WRITE = READ_CONTROL
Const KEY_WRITE = STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY
Const REG_SZ = 1&

Public Function RegGetValue(H_KEY As Long, RSubKey As String, ValueName As String)
   
   Dim nRet As Long, hKey As Long, nType As Long, nBytes As Long
   Dim vValue As Variant
   Dim Buffer As String
   nRet = RegOpenKeyEx(H_KEY, RSubKey, 0&, KEY_ALL_ACCESS, hKey): If nRet <> 0 Then Exit Function
   nRet = RegQueryValueEx(hKey, ValueName, 0&, nType, ByVal Buffer, nBytes): If nRet <> 0 Then Exit Function ' Determine how large the buffer needs to be
   If nBytes <= 0 Then GoTo EndVal
   Buffer = Space(nBytes)
   nRet = RegQueryValueEx(hKey, ValueName, 0&, nType, ByVal Buffer, Len(Buffer)): If nRet = 0 Then RegGetValue = Left(Buffer, nBytes - 1) ' Trim NULL and return successful query!

EndVal:
   RegCloseKey hKey

End Function

Public Sub RegMakeKey(H_KEY As Long, RSubKey As String) 'H_KEY must be one of the Key Constants
    
   Dim lRtn As Long, hKey As Long, lpDisp As Long
   Dim Sec_Att As SECURITY_ATTRIBUTES
   With Sec_Att
     .nLength = 12&
     .lpSecurityDescriptor = 0&
     .bInheritHandle = False
   End With
   lRtn = RegCreateKeyEx(H_KEY, RSubKey, 0&, "", 0&, KEY_WRITE, Sec_Att, hKey, lpDisp): If lRtn <> 0 Then Exit Sub 'No key open, so leave
   lRtn = RegCloseKey(hKey)

End Sub

Public Sub RegSetValue(H_KEY As Long, RSubKey As String, ValueName As String, RegValue As String) 'H_KEY must be one of the Key Constants
    
   Dim lRtn As Long, hKey As Long, lpDisp As Long
   Dim Sec_Att As SECURITY_ATTRIBUTES
   With Sec_Att
     .nLength = 12&
     .lpSecurityDescriptor = 0&
     .bInheritHandle = False
   End With
   lRtn = RegOpenKeyEx(H_KEY, RSubKey, 0&, KEY_ALL_ACCESS, hKey): If lRtn <> 0 Then Exit Sub
   lRtn = RegSetValueEx(hKey, ValueName, 0&, REG_SZ, ByVal RegValue, CLng(Len(RegValue) + 1)): If lRtn <> 0 Then Exit Sub
   lRtn = RegCloseKey(hKey)

End Sub

Public Sub RegShootTheDamnKey(H_KEY As Long, RSubKey As String)
   
   RegDeleteKey H_KEY, RSubKey

End Sub

Public Sub RegShootTheDamnValue(H_KEY As Long, RSubKey As String, ValueName As String)
    
   Dim lRtn As Long, hKey As Long
   lRtn = RegOpenKeyEx(H_KEY, RSubKey, 0&, KEY_ALL_ACCESS, hKey): If lRtn <> 0 Then Exit Sub
   lRtn = RegDeleteValue(hKey, ValueName): If lRtn <> 0 Then Exit Sub
   lRtn = RegCloseKey(hKey)

End Sub


